/*
* JBoss, Home of Professional Open Source
* Copyright 2009, JBoss Inc., and individual contributors as indicated
* by the @authors tag. See the copyright.txt in the distribution for a
* full listing of individual contributors.
*
* This is free software; you can redistribute it and/or modify it
* under the terms of the GNU Lesser General Public License as
* published by the Free Software Foundation; either version 2.1 of
* the License, or (at your option) any later version.
*
* This software is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
* Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this software; if not, write to the Free
* Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
* 02110-1301 USA, or see the FSF site: http://www.fsf.org.
*/
package org.jboss.test.remoting.JBPAPP_8030;

//import java.io.IOException;
//import java.lang.reflect.Field;
//import java.net.InetAddress;
//import java.util.HashMap;
//import java.util.Map;
//import java.util.concurrent.CountDownLatch;
//
//import javax.management.MBeanServer;
//
import junit.framework.TestCase;
//
//import org.apache.log4j.ConsoleAppender;
//import org.apache.log4j.Level;
//import org.apache.log4j.Logger;
//import org.apache.log4j.PatternLayout;
//import org.jboss.remoting.Client;
//import org.jboss.remoting.ConnectionListener;
//import org.jboss.remoting.ConnectionValidator;
//import org.jboss.remoting.InvocationRequest;
//import org.jboss.remoting.InvokerLocator;
//import org.jboss.remoting.InvokerRegistry;
//import org.jboss.remoting.LeasePinger;
//import org.jboss.remoting.MicroRemoteClientInvoker;
//import org.jboss.remoting.Remoting;
//import org.jboss.remoting.ServerInvocationHandler;
//import org.jboss.remoting.ServerInvoker;
//import org.jboss.remoting.callback.InvokerCallbackHandler;
//import org.jboss.remoting.transport.ClientFactory;
//import org.jboss.remoting.transport.ClientInvoker;
//import org.jboss.remoting.transport.Connector;
//import org.jboss.remoting.transport.PortUtil;
//import org.jboss.remoting.transport.ServerFactory;
//import org.jboss.remoting.transport.socket.SocketClientInvoker;
//import org.jboss.remoting.transport.socket.SocketServerInvoker;


/**
/**
 * Unit test for JBREM-1132.
 * 
 * @author <a href="ron.sigal@jboss.com">Ron Sigal</a>
 * @version 
 * <p>
 * Copyright May 08, 2009
 * </p>
 */
public class DeadlockTestCase extends TestCase
{
//   private static Logger log = Logger.getLogger(DeadlockTestCase.class);
//   
//   private static boolean firstTime = true;
//   
//   protected static final int LEASE_PERIOD = 2000;
//   protected static final int VALIDATOR_PING_TIMEOUT = 1000;
//   protected static final int VALIDATOR_PING_PERIOD = 2000;
//   protected static final int PING_PERIODS_TO_WAIT = 2;
//   
//   protected static String locatorURI;
//   
//   protected String host;
//   protected int port;
//   protected InvokerLocator serverLocator;
//   protected Connector connector;
//   protected TestInvocationHandler invocationHandler;
//   protected TestConnectionListener serverConnectionListener;
//
//   
//   public void setUp() throws Exception
//   {
//      if (firstTime)
//      {
//         firstTime = false;
//         Logger.getLogger("org.jboss.remoting").setLevel(Level.INFO);
//         Logger.getLogger("org.jboss.test.remoting").setLevel(Level.INFO);
//         String pattern = "[%d{ABSOLUTE}] [%t] %5p (%F:%L) - %m%n";
//         PatternLayout layout = new PatternLayout(pattern);
//         ConsoleAppender consoleAppender = new ConsoleAppender(layout);
//         Logger.getRootLogger().addAppender(consoleAppender);
//      }
//      InvokerRegistry.registerInvokerFactories(getTransport(), TestClientFactory.class, TestServerFactory.class);
//   }
//
//   public void tearDown()
//   {
//   }   
//   
   public void testDeadlock() throws Throwable
   {
//      log.info("entering " + getName());
//      
//      // Start server.
//      setupServer();
//      
//      // Create first client. This one passes through TestClientInvoker.establishLease() and gets started.
//      // Then its ConnectionValidator times out waiting for a response to a ping. It calls
//      // TestClientInvoker.terminateLease(), grabs MicroRemoteClientInvoker.clientLeaseLock, and then calls
//      // MicroRemoteClientInvoker.terminateLease(), which calls LeasePinger.stopPing(), which calls
//      // Client.notifyListeners(), which tries to get Client.connectionValidatorLock.
//      setupClient("client 1", true);
//      
//      // Make sure first client gets to TestClientInvoker.establishLease() first.
//      Thread.sleep(2000);
//      
//      // Create second client. This gets Client.connectionValidatorLock, gets into TestClientInvoker.establishLease()
//      // and waits for the first client's ConnectionValidator to time out.  Then it calls
//      // MicroRemoteClientInvoker.establishLease() and tries to get MicroRemoteClientInvoker.clientLeaseLock.
//      ClientThread t = setupClient("client 2", false);
//      
//      // Wait for the ConnectionValidator of the first client to time out.
//      Thread.sleep(VALIDATOR_PING_PERIOD + VALIDATOR_PING_TIMEOUT + 1000);
//      
//      // If there is a deadlock, the second client will hang in Client.connect().  Otherwise, Client.connect()
//      // will return and the thread will terminate.
//      t.join(10000);
//      assertTrue(t.done);
//      
//      shutdownServer();
//      log.info(getName() + " PASSES");
   }
//   
//   protected String getTransport()
//   {
//      return "test";
//   }
//   
//   protected void setupServer() throws Exception
//   {
//      host = InetAddress.getLocalHost().getHostAddress();
//      port = PortUtil.findFreePort(host);
//      locatorURI = getTransport() + "://" + host + ":" + port;
//      serverLocator = new InvokerLocator(locatorURI);
//      log.info("Starting remoting server with locator uri of: " + locatorURI);
//      HashMap config = new HashMap();
//      config.put(InvokerLocator.FORCE_REMOTE, "true");
//      connector = new Connector(serverLocator, config);
//      connector.create();
//      invocationHandler = new TestInvocationHandler();
//      connector.addInvocationHandler("test", invocationHandler);
//      connector.setLeasePeriod(LEASE_PERIOD);
//      serverConnectionListener = new TestConnectionListener("serverConnectionListener");
//      connector.addConnectionListener(serverConnectionListener);
//      connector.start();
//   }
//   
//   protected void shutdownServer() throws Exception
//   {
//      if (connector != null)
//         connector.stop();
//   }
//   
//   protected ClientThread setupClient(final String name, boolean startConnectorValidator) throws Exception
//   {
//      ClientThread t = new ClientThread(name, startConnectorValidator);
//      t.start();
//      return t;
//   }
//   
//   
//   static class ClientThread extends Thread
//   {
//      private String name;
//      private boolean startConnectorValidator;
//      public Client client;
//      public boolean done;
//      
//      public ClientThread(String name, boolean startConnectorValidator)
//      {
//         this.name = name;
//         this.startConnectorValidator = startConnectorValidator;
//         setName("ClientThread[" + name + "]");
//      }
//      
//      public void run()
//      {
//         try
//         {
//            InvokerLocator clientLocator = new InvokerLocator(locatorURI);
//            HashMap clientConfig = new HashMap();
//            clientConfig.put(InvokerLocator.FORCE_REMOTE, "true");
//            clientConfig.put(Client.ENABLE_LEASE, "true");
//            clientConfig.put(ConnectionValidator.FAILURE_DISCONNECT_TIMEOUT, "0");
//            clientConfig.put(Remoting.USE_CLIENT_CONNECTION_IDENTITY, "true");
//            clientConfig.put("timeout", "3600000");
//            client = new Client(clientLocator, clientConfig);
//            log.info(name + " is connecting");
//            client.connect();
//            log.info(name + " is connected");
//            if (startConnectorValidator)
//            {
//               HashMap metadata = new HashMap();
//               metadata.put(ConnectionValidator.VALIDATOR_PING_PERIOD, Integer.toString(VALIDATOR_PING_PERIOD));
//               metadata.put(ConnectionValidator.VALIDATOR_PING_TIMEOUT, Integer.toString(VALIDATOR_PING_TIMEOUT));
//               TestConnectionListener listener = new TestConnectionListener(name + " listener");
//               client.addConnectionListener(listener, metadata);
//               log.info(name + ": added connection listener");
//            }
//            done = true;
//         }
//         catch (Exception e)
//         {
//            e.printStackTrace();
//         }  
//      }
//   }
//   
//   
//   static class TestInvocationHandler implements ServerInvocationHandler
//   {
//      public void addListener(InvokerCallbackHandler callbackHandler) {}
//      public Object invoke(final InvocationRequest invocation) throws Throwable
//      {
//         return invocation.getParameter();
//      }
//      public void removeListener(InvokerCallbackHandler callbackHandler) {}
//      public void setMBeanServer(MBeanServer server) {}
//      public void setInvoker(ServerInvoker invoker) {}
//   }
//
//   
//   static class TestConnectionListener implements ConnectionListener
//   {
//      String name;
//      Throwable throwable;
//      int calledCounter;
//      
//      public TestConnectionListener(String name)
//      {
//         this.name = name;
//      }
//      public void handleConnectionException(Throwable throwable, Client client)
//      {
//         calledCounter++;
//         this.throwable = throwable;
//         log.info(name + " notified: throwable = " + throwable);
//      }  
//   }
//   
//   
//   static class TestClientInvoker extends SocketClientInvoker
//   {
//      static int count;
//      static CountDownLatch latch = new CountDownLatch(2);
//      
//      public TestClientInvoker(InvokerLocator locator, Map configuration)
//      {
//         super(locator, configuration);
//      }
//
//      public TestClientInvoker(InvokerLocator locator)
//      {
//         super(locator);
//      }
//      
//      public void establishLease(String clientSessionID, Map configuration, long leasePeriod) throws Throwable
//      {
//         log.info(this + " Already got connectionValidatorLock in setupClientLease()");
//         // Let first one through.
//         if (count++ > 0)
//         {
//            Thread.sleep(5000);
//         }
//         // At this point, the other client's ConnectionValidator should have timed out.
//         // Before JBREM-1297, it would have called this.terminateLease(), where it would have
//         // gotten clientLeaseLock, leading to a deadlock.  After JBREM-1297, ConnectionValidator
//         // tries to get connectionValidatorLock before calling this.terminateLease(), and has
//         // to wait on this call to establishLease() to conclude before proceeding.
//         log.info(this + " calling super.establishLease(), where it will try to get clientLeaselock");
//         super.establishLease(clientSessionID, configuration, leasePeriod);
//      }
// 
//      public void terminateLease(String sessionId, int disconnectTimeout, LeasePinger passedLeasePinger)
//      {
//         try
//         {
//            Field field = MicroRemoteClientInvoker.class.getDeclaredField("clientLeaseLock");
//            field.setAccessible(true);
//            Object clientLeaseLock = field.get(this);
//    
//            // super.terminateLease() gets clientLeaseLock immediately anyway.
//            synchronized(clientLeaseLock)
//            {
//               log.info(this + " got clientLeaseLock in " + this + ".terminateLease()");
//               log.info(this + " calling super.terminateLease() which will call LeasePinger.stopPing()");
//               log.info(this + " which will call Client.notifyListeners() which will try to get connectionValidatorLock");
//               super.terminateLease(sessionId, disconnectTimeout, passedLeasePinger);
//            }
//         }
//         catch (Exception e)
//         {
//            e.printStackTrace();
//         }
//      }
//      
//      public String toString()
//      {
//         String s = super.toString();
//         int i = s.indexOf('[');
//         return "TestClientInvoker" + s.substring(i);
//      }
//   }
//   
//   
//   static class TestServerInvoker extends SocketServerInvoker
//   {
//      int counter;
//      
//      public TestServerInvoker(InvokerLocator locator, Map configuration)
//      {
//         super(locator, configuration);
//      }
//      public TestServerInvoker(InvokerLocator locator)
//      {
//         super(locator);
//      }
//    
//      public Object invoke(InvocationRequest invocation) throws Throwable
//      {
//         log.info(this + ".invoke(): " + invocation);
//         if (isConnectionValidatorPing(invocation))
//         {
//            log.info("got ConnectorValidator ping: going to sleep");
//            Thread.sleep(VALIDATOR_PING_TIMEOUT * 2);
//            log.info("waking up");
//         }
//         return super.invoke(invocation);
//      }
//      
//      public String toString()
//      {
//         String s = super.toString();
//         int i = s.indexOf('[');
//         return "TestServerInvoker" + s.substring(i);
//      }
//      
//      
//      private boolean isConnectionValidatorPing(InvocationRequest invocation)
//      {
//         Object param = invocation.getParameter();         
//         if (!"$PING$".equals(param))
//         {
//            return false;
//         }
//         Map metadata = invocation.getRequestPayload();
//         log.info("metadata: " + metadata);
//         if (metadata == null)
//         {
//            return true;
//         }
//         if (metadata.entrySet().size() == 1)
//         {
//            if (metadata.get(Remoting.USE_SERVER_CONNECTION_IDENTITY) != null ||
//                metadata.get(ServerInvoker.INVOKER_SESSION_ID) != null)
//            {
//               return true;
//            }
//         }
//         if (metadata.entrySet().size() == 2)
//         {
//            if (metadata.get(Remoting.USE_SERVER_CONNECTION_IDENTITY) != null &&
//                metadata.get(ServerInvoker.INVOKER_SESSION_ID) != null)
//            {
//               return true;
//            }
//         }
//         return false;
//      }
//   }
//   
//   
//   public static class TestClientFactory implements ClientFactory
//   {
//      public ClientInvoker createClientInvoker(InvokerLocator locator, Map config) throws IOException
//      {
//         log.info("TestClientFactory.createClientInvoker() called");
//         return new TestClientInvoker(locator, config);
//      }
//      public boolean supportsSSL()
//      {
//         return false;
//      }  
//   }
//   
//   
//   public static class TestServerFactory implements ServerFactory
//   {
//      public ServerInvoker createServerInvoker(InvokerLocator locator, Map config) throws IOException
//      {
//         log.info("TestServerFactory.createServerInvoker() called");
//         return new TestServerInvoker(locator, config);
//      }
//      public boolean supportsSSL()
//      {
//         return false;
//      }
//   }
}