package org.jboss.test.remoting.tests;

import java.io.DataInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.OutputStream;
import java.net.Socket;

public class TestClient
{

   /**
    * @param args
    */
   public static void main(String[] args)
   {
      try
      {
         Socket s = new Socket("localhost", 7777);
         OutputStream os = s.getOutputStream();
         final ObjectOutputStream oos = new ObjectOutputStream(os);
         InputStream is = s.getInputStream();
         final ObjectInputStream ois = new ObjectInputStream(is);
//         int i = 0;
//         while (true) 
//         {
//            System.out.println(is.read());
//            System.out.println(dis.readInt());
//            if (i++ == 10) {
//               is.close();
//               s.close();
//               break;
//            }
//         }
         
         Thread t1 = new Thread() {
            public void run() {
               System.out.println(this + " starting");
               for (int i = 0; ; i++) {
                  try
                  {
                     System.out.println(ois.readObject());
                  }
                  catch (Exception e)
                  {
                     e.printStackTrace();
                  }
               }
            }
         };
         t1.setDaemon(true);
         
         Thread t2 = new Thread() {
            public void run() {
               System.out.println(this + " starting");
               for (int i = 0; ; i++) {
                  try
                  {
                     oos.writeObject(new Integer(i));
                     oos.flush();
                     Thread.sleep(500);
                  }
                  catch (Exception e)
                  {
                     e.printStackTrace();
                  }
               }
            }
         };
         t2.setDaemon(true);
         
         t1.start();
         t2.start();
         
         Thread.sleep(100000);
      }
      catch (Exception e)
      {
         e.printStackTrace();
      }
   }

}
