package org.jboss.test.remoting.tests;

import java.io.DataOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.OutputStream;
import java.net.InetAddress;
import java.net.ServerSocket;
import java.net.Socket;

public class TestServer
{

   /**
    * @param args
    */
   public static void main(String[] args)
   {
      try
      {
         ServerSocket ss = new ServerSocket(7777, 200, InetAddress.getLocalHost());
         Socket s = ss.accept();
//         OutputStream os = s.getOutputStream();
//         DataOutputStream dos = new DataOutputStream(os);
//         for (int i = 0; i < 10; i++)
//         {
//            os.write(i);
////            dos.writeInt(i);
//            Thread.sleep(200);
//         }
         
         OutputStream os = s.getOutputStream();
         final ObjectOutputStream oos = new ObjectOutputStream(os);
         InputStream is = s.getInputStream();
         final ObjectInputStream ois = new ObjectInputStream(is);
         
         Thread t1 = new Thread() {
            public void run() {
               System.out.println(this + " starting");
               for (int i = 0; ; i++) {
                  try
                  {
                     ois.readObject();
                     System.out.println(ois.readObject());
                  }
                  catch (Exception e)
                  {
                     e.printStackTrace();
                  }
               }
            }
         };
         t1.setDaemon(true);
         
         Thread t2 = new Thread() {
            public void run() {
               System.out.println(this + " starting");
               for (int i = 0; ; i++) {
                  try
                  {
                     oos.writeObject(new Integer(i));
                     oos.flush();
                     Thread.sleep(500);
                  }
                  catch (Exception e)
                  {
                     e.printStackTrace();
                  }
               }
            }
         };
         t2.setDaemon(true);
         
         t1.start();
         t2.start();
         
         Thread.sleep(100000);
         s.close();
      }
      catch (Exception e)
      {
         e.printStackTrace();
      }
   }

}
