package org.jboss.test.remoting.tests;

import java.io.IOException;
import java.io.OutputStream;
import java.net.InetAddress;
import java.net.Socket;
import java.net.UnknownHostException;
import java.util.Date;

public class WriteTimeoutClient
{

   /**
    * @param args
    */
   public static void main(String[] args)
   {
      try
      {
         System.out.println(new Date() + " starting");
         Socket s = new Socket(InetAddress.getByName("192.168.2.3"), 8888);
         OutputStream os = s.getOutputStream();
         System.out.println(new Date() + ": waiting 20 seconds");
         Thread.sleep(20000);
         System.out.println(new Date() + ": woke up");
         byte[] b = new byte[1024 * 64];
         os.write("hello 1".getBytes());
         os.write(b);
         System.out.println("wrote hello 1");
         Thread.sleep(5000);
         os.write("hello 2".getBytes());
         os.write(b);
         System.out.println("wrote hello 2");
         Thread.sleep(5000);
         os.write("hello 3".getBytes());
         os.write(b);
         System.out.println("wrote hello 3");         
         s.close();
      }
      catch (UnknownHostException e)
      {
         e.printStackTrace();
      }
      catch (IOException e)
      {
         e.printStackTrace();
      }
      catch (InterruptedException e)
      {
         e.printStackTrace();
      }
      finally
      {
         System.out.println(new Date() + ": shutting down");
      }
   }

}
